#include "stm32f10x.h"
#include "init_periph.h"


uint16_t i;

void delay_ms(uint32_t ms);
void uart_send(void);
void uart1_send_byte(uint8_t c);

uint16_t data_adc_laser[128];
uint16_t data_adc_off[128];

tx_status_type tx_status = DONE;


int main()
{
  DBGMCU_Config  (DBGMCU_TIM1_STOP,ENABLE); 
  
  GPIO_InitTypeDef  GPIO_InitStructure;
  
  RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA|RCC_APB2Periph_GPIOB |RCC_APB2Periph_GPIOC| RCC_APB2Periph_AFIO, ENABLE);
  
  GPIO_InitStructure.GPIO_Pin   = LED_PIN;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_Mode  = GPIO_Mode_Out_PP;
  GPIO_Init(LED_PORT, &GPIO_InitStructure);
  
  //init_all_periph();   
  delay_ms(100);
  
  while(1)
  {
    LED_PORT->ODR^= LED_PIN;
    delay_ms(500);
  }
  
  
  
  while(1)
  {
      cap_start((uint32_t*)&data_adc_off[0]);// ,  
      while(tx_status != DONE){asm("nop");}
      enable_laser();
      cap_start((uint32_t*)&data_adc_off[0]);// ,   
      while(tx_status != DONE){asm("nop");}
      disable_laser();
      cap_start((uint32_t*)&data_adc_laser[0]);// ,  c 
      while(tx_status != DONE){asm("nop");}
      
      uart_send();
      delay_ms(100);
  }
  
  return 0;
}








void delay_ms(uint32_t ms)
{
        volatile uint32_t nCount;
        RCC_ClocksTypeDef RCC_Clocks;
        RCC_GetClocksFreq (&RCC_Clocks);
        nCount=(RCC_Clocks.HCLK_Frequency/10000)*ms;
        for (; nCount!=0; nCount--);
}


void uart_send(void)
{
  uint8_t i;
  
//  for (i=0;i<128;i++)
//  {
//    uart1_send_byte((data_adc[i]>>4));
//  }
  
  uart1_send_byte(0);
  uart1_send_byte(0);
  
  for (i=0;i<128;i++)
  {
    
    if (data_adc_laser[i] > data_adc_off[i]) {data_adc_laser[i] = data_adc_laser[i] - data_adc_off[i];} else {data_adc_laser[i] = 0;}
    
    uart1_send_byte((data_adc_laser[i]>>10));
    uart1_send_byte((data_adc_laser[i]>>2) & 0xFF);
  }
}

void uart1_send_byte(uint8_t c)
{
    USART_SendData(USART1, c);
    while(USART_GetFlagStatus(USART1, USART_FLAG_TXE) == RESET );
}
