#include "stm32f10x.h"

#ifndef _INIT_PERIPH
#define _INIT_PERIPH

#define SPI1_DR_Address      0x4001300C

#define ADC1_DR_Address    ((uint32_t)0x4001244C)

typedef enum
{
  TRANSFER = 0,
  DONE,
}tx_status_type;

typedef enum
{
  PWM = 0,
  GPIO,
}clk_pin_type;

#define SI_PIN GPIO_Pin_10
#define SI_PORT GPIOA

#define CLK_PIN GPIO_Pin_8
#define CLK_PORT GPIOA

// 
#define MOD_PIN GPIO_Pin_6
#define MOD_PORT GPIOC

// 
#define LED_PIN GPIO_Pin_7
#define LED_PORT GPIOB


void init_all_periph(void);
void init_clk(void);
void init_gpio(void);
void init_spi(void);
void init_dma(void);

void dma_config(uint32_t* pointer);
void cap_start(uint32_t* pointer);
void ext_int_init(void);
void timer1_init(void);
void init_adc(void);
void adc_dma_init(void);
void small_delay(void);
void init_clk_pin(clk_pin_type pin_type);
void init_uart1(void);
void enable_laser(void);
void disable_laser(void);

#endif











