#include "stm32f10x.h"
#include "init_periph.h"
#include "laser.h"


extern volatile uint16_t* data_adc_laser_p;//    
extern volatile uint16_t* data_adc_off_p;//    
extern volatile uint8_t cap_status;//  1,     
extern volatile meas_status_type meas_status;

// 
void meas_handler(void)
{
  switch(meas_status)
  {
    case PHASE_WAIT:
    {
      disable_hold();
      enable_laser();
      cap_start((uint32_t*)data_adc_off_p);
      meas_status = PHASE_1;
      break;
    }
    case PHASE_1: // 1 
    {
      disable_laser();
      cap_start((uint32_t*)data_adc_laser_p);
      meas_status = PHASE_2;
      break;
    }

    case PHASE_2: // 2 
    {
      enable_hold();//       
      meas_status = PHASE_DONE;
      cap_status = 1;
      break;
    }

    case PHASE_DONE:
    {
      break;
    }
    
  }
  
}