//      (08.2013)
#include "stm32f10x.h"
#include "init_periph.h"
#include "laser.h"
#include "uart_handler.h"


uint16_t i;

void delay_ms(uint32_t ms);
void uart_send(void);
void uart1_send_byte(uint8_t c);

uint16_t data_adc_laser[128];
uint16_t data_adc_off[128];

volatile uint16_t rot_time = 0; // 

volatile uint16_t* data_adc_laser_p = &data_adc_laser[0];//    
volatile uint16_t* data_adc_off_p = &data_adc_off[0];//    

tx_status_type tx_status = DONE;
volatile uint8_t cap_status = 0;//  1,     
volatile meas_status_type meas_status = PHASE_WAIT;//  3 

// 
//   
//3   
//  

int main()
{
  DBGMCU_Config  (DBGMCU_TIM1_STOP,ENABLE);  
  
  init_all_periph();   
  delay_ms(100);
  
  switch_led(1);
  
  
  while(1)
  {
   
      meas_status = PHASE_WAIT;
      meas_handler();
      while(meas_status != PHASE_DONE){asm("nop");}
      
      
      uart_send();
      //delay_ms(100);
  }
  
  return 0;
}


void delay_ms(uint32_t ms)
{
        volatile uint32_t nCount;
        RCC_ClocksTypeDef RCC_Clocks;
        RCC_GetClocksFreq (&RCC_Clocks);
        nCount=(RCC_Clocks.HCLK_Frequency/10000)*ms;
        for (; nCount!=0; nCount--);
}


void uart_send(void)
{
  uint8_t i;
  
  uart1_send_byte(0);
  uart1_send_byte(0);
  
  for (i=0;i<128;i++)
  {
    if (data_adc_laser[i] > data_adc_off[i]) {data_adc_laser[i] = data_adc_laser[i] - data_adc_off[i];} else {data_adc_laser[i] = 0;}
  }
  
  uart_dma_config((uint32_t*)data_adc_laser_p);
  //uart_dma_config((uint32_t*)data_adc_off_p);
  delay_ms(200);//  
}

void uart1_send_byte(uint8_t c)
{
    USART_SendData(USART1, c);
    while(USART_GetFlagStatus(USART1, USART_FLAG_TXE) == RESET );
}
