#include "stm32f10x.h"

#ifndef _INIT_PERIPH
#define _INIT_PERIPH

#define SPI1_DR_Address      0x4001300C

#define ADC1_DR_Address    ((uint32_t)0x4001244C)

typedef enum
{
  TRANSFER = 0,
  DONE,
}tx_status_type;

typedef enum
{
  PWM = 0,
  GPIO,
}clk_pin_type;

#define SI_PIN GPIO_Pin_2
#define SI_PORT GPIOA

#define CLK_PIN GPIO_Pin_8
#define CLK_PORT GPIOA

// 
#define MOD_PIN (uint16_t)(GPIO_Pin_13 | GPIO_Pin_12)
#define MOD_PORT GPIOB

// 
#define LED_PIN GPIO_Pin_7
#define LED_PORT GPIOB

// 
#define ADC_PIN GPIO_Pin_1
#define ADC_PORT GPIOA

// HOLD 
#define HOLD_PIN GPIO_Pin_0
#define HOLD_PORT GPIOB


void init_all_periph(void);
void init_clk(void);
void init_gpio(void);
void init_spi(void);

void dma_config(uint32_t* pointer);
void cap_start(uint32_t* pointer);
void ext_int_init(void);
void timer1_init(void);
void timer2_init(void);
void init_adc(void);
void adc_dma_init(void);
void uart_dma_init(void);
void small_delay(void);
void init_clk_pin(clk_pin_type pin_type);
void init_uart1(void);
void enable_laser(void);
void disable_laser(void);
void switch_led(uint8_t val);

void enable_hold(void);
void disable_hold(void);

#endif











