#include "stm32f10x.h"
#include "init_periph.h"
#include "uart_handler.h"
#include "laser.h"

#define AN_WIDTH_HIGH 8 //   
#define AN_WIDTH_LOW 2 //   

#define REFL_FILTER //    
#define REFL_LIGHT //    -  

// 
extern volatile uint16_t res_buf0[363];
extern volatile uint16_t res_buf1[363];
extern volatile uint8_t  res_buf_num;// ,     

extern volatile uint16_t data_adc_laser0[128];
extern volatile uint16_t data_adc_off0[128];
extern volatile uint16_t data_adc_laser1[128];
extern volatile uint16_t data_adc_off1[128];

//volatile uint16_t data_adc_off2[128];

volatile uint16_t proc_data[128];// 
volatile uint8_t proc_done_flag = 0;//    1
volatile uint8_t bad_point_flag = 0;//  

extern volatile uint16_t* data_adc_laser_p;//    
extern volatile uint16_t* data_adc_off_p;//    
extern volatile meas_status_type meas_status;
extern volatile uint16_t rot_time; // 
extern volatile uint16_t cap_number;//  
extern tx_status_type tx_status;//  

//      
volatile uint16_t* proc_adc_laser_p;//    
volatile uint16_t* proc_adc_off_p;//    

//  
volatile uint16_t capture_old = 0;
volatile uint16_t capture_now = 0;
volatile uint16_t enc_speed = 0;
volatile uint8_t  rot_num = 0;//   

volatile uint8_t AN_WIDTH = AN_WIDTH_HIGH;



// 
//    TIM16    DMA TIM1 -    
void meas_handler(void)
{
  switch(meas_status)
  {
    case PHASE_WAIT:
    {
      disable_hold();
      enable_laser();
      cap_start((uint32_t*)data_adc_off_p);
      meas_status = PHASE_1;
      break;
    }
    case PHASE_1: // 1 
    {
      disable_laser();
      cap_start((uint32_t*)data_adc_laser_p);
      meas_status = PHASE_2;
      break;
    }

    case PHASE_2: // 2 
    {
      enable_hold();//       
      proc_done_flag = 0;
      meas_status = PHASE_DONE;
      break;
    }

    case PHASE_DONE:
    {
      break;
    }
    
  }
  
}


//   
//    TIM16 -    
void switch_adc_buf(void)
{
  if ((cap_number & 1) == 1) //   0 
  {
    data_adc_laser_p = &data_adc_laser0[0];
    data_adc_off_p   = &data_adc_off0[0];
    asm("nop");
  }
  else //   1 
  {
    data_adc_laser_p = &data_adc_laser1[0];
    data_adc_off_p   = &data_adc_off1[0];
  }
}

//   
void process_handler(void)
{
  uint8_t i;
  uint8_t  max_pos = 0;
  uint16_t max_val = 0;
  uint8_t  start_pos;
  uint8_t  stop_pos;
  uint32_t summ = 0;
  uint32_t summ2 = 0;
  uint32_t tmp_centroid = 0;
  
  uint16_t tmp_cap_number = cap_number;//     
  uint8_t  tmp_res_buf_num = res_buf_num;
  int16_t delta1;
  int16_t delta2;
  uint8_t fmax_val = 0;
  
  uint16_t val1 = 0;
  uint16_t val2 = 0;
  

  
  uint16_t off_flag = 0;//2    
  
  
  if ((meas_status == PHASE_DONE) && (proc_done_flag == 0))//        
  {
    proc_adc_laser_p = data_adc_laser_p;
    proc_adc_off_p = data_adc_off_p;
    
#ifdef REFL_LIGHT
    for (i=0;i<128;i++)
    {
      //if (((proc_adc_off_p[i] - proc_adc_laser_p[i]) > 50) && (i<(127-4))) {proc_adc_laser_p[i] = 0; proc_adc_laser_p[i+1] = 0; proc_adc_laser_p[i+2] = 0; proc_adc_laser_p[i+3] = 0; proc_adc_laser_p[i+4] = 0;}
      if (proc_adc_off_p[i] > proc_adc_laser_p[i]) {proc_adc_laser_p[i] = 0;}
    }
    
#endif
    
    for (i=0;i<128;i++)
    {
      //    
      if (proc_adc_laser_p[i] > proc_adc_off_p[i]) {proc_data[i] = proc_adc_laser_p[i] - proc_adc_off_p[i];} else {proc_data[i] = 0;}
      if (proc_data[i] > max_val) {max_val = proc_data[i]; max_pos = i;}// 
      //if ((data_adc_off2[i] > proc_adc_off_p[i]) && ((data_adc_off2[i] - proc_adc_off_p[i]) > 100)) {off_flag = 1;}
    }
    
    if (max_pos < 20) {AN_WIDTH = AN_WIDTH_LOW;} else {AN_WIDTH = AN_WIDTH_HIGH;}
    
#ifndef REFL_FILTER
    if (max_pos < AN_WIDTH) {max_pos = AN_WIDTH;}
    if (max_pos > (127-AN_WIDTH)) {max_pos = (127-AN_WIDTH);}
    start_pos = max_pos - AN_WIDTH;
    stop_pos =  max_pos + AN_WIDTH;
#endif
    
#ifdef REFL_FILTER

    if ((max_pos < AN_WIDTH) || (max_pos > (127-AN_WIDTH)))
    {
      //  
      if (max_pos < AN_WIDTH) {max_pos = AN_WIDTH;}
      if (max_pos > (127-AN_WIDTH)) {max_pos = (127-AN_WIDTH);}
      start_pos = max_pos - AN_WIDTH;
      stop_pos =  max_pos + AN_WIDTH;
    }
    else
    { 
     
      start_pos = max_pos - AN_WIDTH;
      stop_pos =  max_pos + AN_WIDTH;
      
      for (i=(start_pos+1);i<(stop_pos-1);i++)
      {
        
        delta1 = (int16_t)proc_data[i] - (int16_t)proc_data[i-1];
        delta2 = (int16_t)proc_data[i+1] - (int16_t)proc_data[i];
        
        if ((delta1 > 0) && (delta2 < 0) && (i != max_pos))
        {
          // 
          if (fmax_val < proc_data[i]) {fmax_val = proc_data[i];}
        }
        
      }
      val1 = max_val/15;
      val2 = max_val*2/3;
      
      if ((fmax_val > val1) && (fmax_val < val2)) {off_flag = 1;}
    }
    
#endif
    
    

    //  
    for (i = start_pos;i<stop_pos;i++)
    {
      summ = summ + i * proc_data[i];
      summ2 = summ2 + proc_data[i];				
    }
    
    if (summ2 > 0) {tmp_centroid = ((summ*100) / summ2) + 100;}
	
    if (max_val < 50)  {tmp_centroid = 1;}//    
    if (max_pos < 6)   {tmp_centroid = 2;}//    
    if (max_pos > 126) {tmp_centroid = 3;}//      
    if (bad_point_flag == 1) {tmp_centroid = 3; bad_point_flag = 0;}
    
   
    
    if (off_flag == 1) {tmp_centroid = tmp_centroid + 20000;}
    
    tmp_centroid = 2500;//  UART
    
    
    //    
    //if (cap_number < 359)
    {
      if (tmp_res_buf_num == 0) {res_buf0[tmp_cap_number+2] = (uint16_t)tmp_centroid;} else {res_buf1[tmp_cap_number+2] = (uint16_t)tmp_centroid;}
    }
    proc_done_flag = 1;//   
  }
}







//  
void stop_capture(void)
{
  
  TIM1->CR1 &= (uint16_t)(~((uint16_t)TIM_CR1_CEN));//  
  TIM_SetCounter(TIM1,0);
  DMA_Cmd(DMA1_Channel1, DISABLE);
  
  meas_status = PHASE_WAIT;
  tx_status = TRANSFER; 
  cap_number = 0;
  rot_num = 0;
  res_buf_num^= 1;//  
  clear_buffer();
  bad_point_flag = 1;
}



//  ,          1 
//    TIM3 ()   
void refresh_sync_timer(uint16_t time)
{
  
  TIM16->CR1&= ~TIM_CR1_CEN;//disable timer
  TIM_SetCounter(TIM16,0);
  TIM_SetAutoreload(TIM16,time);
  TIM_SetCompare1(TIM16,(time/2));
  TIM16->EGR |= TIM_EGR_UG;//clear prescaler
  TIM16->CR1 |= TIM_CR1_CEN;//enable timer
}

//   1.5    -  1
//    
uint8_t check_zero_point(uint16_t time)
{
  static uint16_t times[4];
  static uint8_t pos = 0;//pos = 0-3
  uint16_t avr_time = 0;// 
  uint16_t result;
  
  times[pos] = time;
  pos++;
  pos&=3;
  avr_time = (times[0] + times[1] + times[2] + times[3]) >> 2;
  time=time << 2;//*4
  result = time/avr_time;
  if (result >= 5) {return 1;} else {return 0;}//6/4 = 1.5
}