/* Includes ------------------------------------------------------------------*/
#include "stm32f10x_it.h"
#include "init_periph.h"
#include "laser.h"
#include "uart_handler.h"

extern volatile uint16_t rot_time; // 
extern tx_status_type tx_status;
extern volatile uint16_t cap_number;//  
extern volatile meas_status_type meas_status;//  3 

//  
extern uint16_t capture_old;
extern uint16_t capture_now;
extern uint16_t enc_speed;


volatile uint16_t time_tmp;//   1 
extern volatile uint8_t  rot_num;//   



/** @addtogroup STM32F10x_StdPeriph_Template
  * @{
  */

/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/

/******************************************************************************/
/*            Cortex-M3 Processor Exceptions Handlers                         */
/******************************************************************************/

/**
  * @brief   This function handles NMI exception.
  * @param  None
  * @retval None
  */
void NMI_Handler(void)
{
}

/**
  * @brief  This function handles Hard Fault exception.
  * @param  None
  * @retval None
  */
void HardFault_Handler(void)
{
  /* Go to infinite loop when Hard Fault exception occurs */
  while (1)
  {
  }
}

/**
  * @brief  This function handles Memory Manage exception.
  * @param  None
  * @retval None
  */
void MemManage_Handler(void)
{
  /* Go to infinite loop when Memory Manage exception occurs */
  while (1)
  {
  }
}

/**
  * @brief  This function handles Bus Fault exception.
  * @param  None
  * @retval None
  */
void BusFault_Handler(void)
{
  /* Go to infinite loop when Bus Fault exception occurs */
  while (1)
  {
  }
}

/**
  * @brief  This function handles Usage Fault exception.
  * @param  None
  * @retval None
  */
void UsageFault_Handler(void)
{
  /* Go to infinite loop when Usage Fault exception occurs */
  while (1)
  {
  }
}

/**
  * @brief  This function handles SVCall exception.
  * @param  None
  * @retval None
  */
void SVC_Handler(void)
{
}

/**
  * @brief  This function handles Debug Monitor exception.
  * @param  None
  * @retval None
  */
void DebugMon_Handler(void)
{
}

/**
  * @brief  This function handles PendSVC exception.
  * @param  None
  * @retval None
  */
void PendSV_Handler(void)
{
}

/**
  * @brief  This function handles SysTick Handler.
  * @param  None
  * @retval None
  */
void SysTick_Handler(void)
{
}

/******************************************************************************/
/*                 STM32F10x Peripherals Interrupt Handlers                   */
/*  Add here the Interrupt Handler for the used peripheral(s) (PPP), for the  */
/*  available peripheral interrupt handler's name please refer to the startup */
/*  file (startup_stm32f10x_xx.s).                                            */
/******************************************************************************/

// ,   
// 
void TIM1_UP_TIM16_IRQHandler(void)
{
  TIM16->SR &= ~TIM_SR_CC1IF;//  
  if (cap_number < 359)
  {
    meas_status = PHASE_WAIT;//   
    cap_number++;
    switch_adc_buf();
    meas_handler(); //start capture 
  }
  
}

//   
void TIM3_IRQHandler(void)
{
  
  if (TIM_GetITStatus(TIM3, TIM_IT_CC1) != RESET)
  {
    TIM_ClearITPendingBit(TIM3, TIM_IT_CC1);
    //LED_PORT->ODR^= LED_PIN;
    
    capture_old = capture_now;
    capture_now = TIM_GetCapture1(TIM3);
    
    // 
    if (capture_now >= capture_old) {enc_speed = capture_now - capture_old;} else {enc_speed = 0xFFFF - capture_old + capture_now;}
    //if (enc_speed < ENC_ROT_TIME) {switch_led(1);enc_speed = ENC_ROT_TIME;} else {switch_led(0);}
    time_tmp = enc_speed / ENC_DEG;// 60  ENC_DEG = 6
  
    rot_num++;
    
    if (check_zero_point(time_tmp) == 1)// 0
    {
      if (rot_num != 59) {switch_led(1);} else {switch_led(0);}
      stop_capture();
      refresh_sync_timer(time_tmp);
      start_send_result();
    }
    
    //  
    TIM_SetAutoreload(TIM16,time_tmp-1);
    TIM_SetCompare1(TIM16,(time_tmp/2)-1);
    
  }
}


//  TIM1  
void DMA1_Channel1_IRQHandler(void)
{  
  /* DMA1 Channel1 transfer COMPLETE interrupt */
  if(DMA_GetITStatus(DMA1_IT_TC1)) //  
  {
    TIM1->CR1 &= (uint16_t)(~((uint16_t)TIM_CR1_CEN));//  
    TIM_SetCounter(TIM1,0);
    DMA_Cmd(DMA1_Channel1, DISABLE);
    asm("nop");
    tx_status = DONE; 
    
    meas_handler(); //start capture 
  }//end if
  
  /*DMA1 Channel1 transfer ERROR interrupt */
  if(DMA_GetITStatus(DMA1_IT_TE1)){DMA_ClearITPendingBit(DMA1_IT_TE1);}
  
  DMA1->IFCR = DMA_IFCR_CGIF1;//     
}



// 
void TIM1_CC_IRQHandler(void)
{
  TIM1->SR &=~TIM_SR_CC1IF;
}